gio-0.12.4: Binding to the GIO.

Portability | portable (depends on GHC)
Stability | alpha
Maintainer | gtk2hs-devel@lists.sourceforge.net
Safe Haskell | None

System.GIO.File.MountOperation

Contents

- Details
- Types
- Enums
- Methods
- Attributes
- Signals

Description

Synopsis

- newtype MountOperation = MountOperation (ForeignPtr MountOperation)
- class GObjectClass o => MountOperationClass o
- data MountOperationResult
  - = MountOperationHandled
  - | MountOperationAborted
  - | MountOperationUnhandled
- data AskPasswordFlags
  - = AskPasswordNeedPassword
  - | AskPasswordNeedUsername
  - | AskPasswordNeedDomain
  - | AskPasswordSavingSupported
  - | AskPasswordAnonymousSupported
- data PasswordSave
  - = PasswordSaveNever
  - | PasswordSaveForSession
  - | PasswordSavePermanently
- mountOperationNew :: IO MountOperation
- mountOperationReply :: MountOperationClass op => op -> MountOperationResult -> IO ()
- mountOperationAnonymous :: MountOperationClass op => Attr op Bool
- mountOperationChoice :: MountOperationClass op => Attr op Int
- mountOperationDomain :: MountOperationClass op => Attr op String
- mountOperationPassword :: MountOperationClass op => Attr op String
- mountOperationPasswordSave :: MountOperationClass op => Attr op PasswordSave
- mountOperationUsername :: MountOperationClass op => Attr op String
- mountOperationAborted :: MountOperationClass op => Signal op (IO ())
- mountOperationAskPassword :: MountOperationClass op => Signal op (String -> String -> String -> AskPasswordFlags -> IO ())
- mountOperationReplySignal :: MountOperationClass op => Signal op (MountOperationResult -> IO ())

# Details

`MountOperation` provides a mechanism for interacting with the user. It can be used for authenticating mountable operations, such as loop mounting files, hard drive partitions or server locations. It can also be used to ask the user questions or show a list of applications preventing unmount or eject operations from completing.

Note that `Mount`Operation is used for more than just `Mount` objects – for example it is also used in `driveStart`.

Users should instantiate a subclass of this that implements all the various callbacks to show the required dialogs, such as `MountOperation`. If no user interaction is desired (for example when automounting filesystems at login time), usually `Nothing` can be passed, see each method taking a `MountOperation` for details.

# Types

newtype MountOperation

Constructors

MountOperation (ForeignPtr MountOperation) |

Instances

Eq MountOperation |
Ord MountOperation |
GObjectClass MountOperation |
MountOperationClass MountOperation |

class GObjectClass o => MountOperationClass o

Instances

MountOperationClass MountOperation |

# Enums

data MountOperationResult

Constructors

MountOperationHandled |
MountOperationAborted |
MountOperationUnhandled |

Instances

Bounded MountOperationResult |
Enum MountOperationResult |
Eq MountOperationResult |
Ord MountOperationResult |
Show MountOperationResult |
Typeable MountOperationResult |

data AskPasswordFlags

Constructors

AskPasswordNeedPassword |
AskPasswordNeedUsername |
AskPasswordNeedDomain |
AskPasswordSavingSupported |
AskPasswordAnonymousSupported |

Instances

Bounded AskPasswordFlags |
Enum AskPasswordFlags | `MountOperationResult` is returned as a result when a request for information is send by the mounting operation.
Eq AskPasswordFlags |
Ord AskPasswordFlags |
Show AskPasswordFlags |
Typeable AskPasswordFlags |
Flags AskPasswordFlags |

data PasswordSave

`PasswordSave` is used to indicate the lifespan of a saved password.

Constructors

PasswordSaveNever |
PasswordSaveForSession |
PasswordSavePermanently |

Instances

Bounded PasswordSave |
Enum PasswordSave |
Eq PasswordSave |
Ord PasswordSave |
Show PasswordSave |
Typeable PasswordSave |

# Methods

mountOperationNew :: IO MountOperation

Creates a new mount operation.

mountOperationReply :: MountOperationClass op => op -> MountOperationResult -> IO ()

Emits the reply signal.

# Attributes

mountOperationAnonymous :: MountOperationClass op => Attr op Bool

Whether to use an anonymous user when authenticating.

Default value: `False`

mountOperationChoice :: MountOperationClass op => Attr op Int

The index of the user's choice when a question is asked during the mount operation. See the `askQuestion` signal.

Allowed values: >= 0

Default value: 0

mountOperationDomain :: MountOperationClass op => Attr op String

The domain to use for the mount operation.

Default value: ""

mountOperationPassword :: MountOperationClass op => Attr op String

The password that is used for authentication when carrying out the mount operation.

Default value: ""

mountOperationPasswordSave :: MountOperationClass op => Attr op PasswordSave

Determines if and how the password information should be saved.

Default value: `PasswordSaveNever`

mountOperationUsername :: MountOperationClass op => Attr op String

The user name that is used for authentication when carrying out the mount operation.

Default value: ""

# Signals

mountOperationAborted :: MountOperationClass op => Signal op (IO ())

Emitted by the backend when e.g. a device becomes unavailable while a mount operation is in progress.

Implementations of `MountOperation` should handle this signal by dismissing open password dialogs.

Since 2.20

mountOperationAskPassword :: MountOperationClass op => Signal op (String -> String -> String -> AskPasswordFlags -> IO ())

Emitted when a mount operation asks the user for a password.

If the message contains a line break, the first line should be presented as a heading. For example, it may be used as the primary text in a `MessageDialog`.

mountOperationReplySignal :: MountOperationClass op => Signal op (MountOperationResult -> IO ())

Emitted when asking the user a question and gives a list of choices for the user to choose from.

If the message contains a line break, the first line should be presented as a heading. For example, it may be used as the primary text in a `MessageDialog`. askQuestion :: MountOperationClass op => Signal op (String -> [String] -> IO ()) askQuestion Signal (after obj user -> connect_STRING_BOXED__NONE ask-question after obj (message choicesPtr -> do choices <- peekUTFString choicesPtr user str choices))

Emitted when the user has replied to the mount operation.